/*!
 * @file hhbolt.h
 * @brief heavy blaster hbolt
*/

#ifndef _HBOLT_H
#define _HBOLT_H

#include "projectile.h"

class Vector;
class Weapon;
class SpriteParticles;
class ParticleEmitter;
class FastFactory;

class HBolt : public Projectile
{
  ObjectListDeclaration(HBolt);
  public:
    HBolt ();
    virtual ~HBolt ();


    virtual void activate();
    virtual void deactivate();

    virtual void collidesWith(WorldEntity* entity, const Vector& location);

    virtual void destroy (WorldEntity* killer);

    virtual void tick (float dt);
    virtual void draw (); //const;

    virtual void updateAngle(float time);
    inline float getAngle() { return this->angle; };

  private:
    static FastFactory*               fastFactory;

    static SpriteParticles*           explosionParticles;

    ParticleEmitter*                  emitter;

    float                             angle;
    float                             rotationSpeed;
    Vector                            axis;

    WorldEntity* hitEntity; // FIXME TEMPORARY
};

#endif /* _HBOLT_H */
